// This file is part of Substrate.

// Copyright (C) 2022 Parity Technologies (UK) Ltd.
// SPDX-License-Identifier: Apache-2.0

// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

//! Autogenerated weights for proposals_discussion
//!
//! THIS FILE WAS AUTO-GENERATED USING THE SUBSTRATE BENCHMARK CLI VERSION 4.0.0-dev
//! DATE: 2022-10-20, STEPS: `50`, REPEAT: 20, LOW RANGE: `[]`, HIGH RANGE: `[]`
//! EXECUTION: Some(Wasm), WASM-EXECUTION: Compiled, CHAIN: Some("dev"), DB CACHE: 1024

// Executed Command:
// ./../target/release/joystream-node
// benchmark
// pallet
// --base-path=/mnt/disks/local-ssd/
// --pallet=proposals_discussion
// --extrinsic=*
// --chain=dev
// --steps=50
// --repeat=20
// --execution=wasm
// --template=./../devops/joystream-pallet-weight-template.hbs
// --output=./../runtime-modules/proposals/discussion/src/weights.rs

#![cfg_attr(rustfmt, rustfmt_skip)]
#![allow(unused_parens)]
#![allow(unused_imports)]
#![allow(unused_variables)]

use frame_support::{traits::Get, weights::Weight};
use sp_std::marker::PhantomData;

/// Weight functions needed for proposals_discussion.
pub trait WeightInfo {
	fn add_post(_j: u32, ) -> Weight;
	fn update_post(_j: u32, ) -> Weight;
	fn delete_post() -> Weight;
	fn change_thread_mode(_i: u32, ) -> Weight;
}

/// Weights for proposals_discussion using the Substrate node and recommended hardware.
pub struct SubstrateWeight<T>(PhantomData<T>);
impl<T: frame_system::Config> WeightInfo for SubstrateWeight<T> {
	// Storage: Membership MembershipById (r:1 w:0)
	// Storage: ProposalDiscussion ThreadById (r:1 w:0)
	// Storage: Council CouncilMembers (r:1 w:0)
	// Storage: ProposalDiscussion PostCount (r:1 w:1)
	// Storage: System Account (r:2 w:2)
	// Storage: ProposalDiscussion PostThreadIdByPostId (r:0 w:1)
	fn add_post(j: u32, ) -> Weight {
		(197_279_000 as Weight)
			// Standard Error: 3_000
			.saturating_add((765_000 as Weight).saturating_mul(j as Weight))
			.saturating_add(T::DbWeight::get().reads(6 as Weight))
			.saturating_add(T::DbWeight::get().writes(4 as Weight))
	}
	// Storage: ProposalDiscussion ThreadById (r:1 w:0)
	// Storage: ProposalDiscussion PostThreadIdByPostId (r:1 w:1)
	// Storage: Membership MembershipById (r:1 w:0)
	fn update_post(j: u32, ) -> Weight {
		(68_938_000 as Weight)
			// Standard Error: 2_000
			.saturating_add((735_000 as Weight).saturating_mul(j as Weight))
			.saturating_add(T::DbWeight::get().reads(3 as Weight))
			.saturating_add(T::DbWeight::get().writes(1 as Weight))
	}
	// Storage: Membership MembershipById (r:1 w:0)
	// Storage: ProposalDiscussion PostThreadIdByPostId (r:1 w:1)
	// Storage: ProposalDiscussion ThreadById (r:1 w:0)
	// Storage: System Account (r:2 w:2)
	fn delete_post() -> Weight {
		(122_960_000 as Weight)
			.saturating_add(T::DbWeight::get().reads(5 as Weight))
			.saturating_add(T::DbWeight::get().writes(3 as Weight))
	}
	// Storage: Membership MembershipById (r:1 w:0)
	// Storage: ProposalDiscussion ThreadById (r:1 w:1)
	// Storage: Council CouncilMembers (r:1 w:0)
	fn change_thread_mode(i: u32, ) -> Weight {
		(72_501_000 as Weight)
			// Standard Error: 34_000
			.saturating_add((10_896_000 as Weight).saturating_mul(i as Weight))
			.saturating_add(T::DbWeight::get().reads(2 as Weight))
			.saturating_add(T::DbWeight::get().reads((1 as Weight).saturating_mul(i as Weight)))
			.saturating_add(T::DbWeight::get().writes(1 as Weight))
	}
}

// Default implementation for tests
impl WeightInfo for () {
	fn add_post(j: u32, ) -> Weight {
		0
	}
	fn update_post(j: u32, ) -> Weight {
		0
	}
	fn delete_post() -> Weight {
		0
	}
	fn change_thread_mode(i: u32, ) -> Weight {
		0
	}
}
